#ifndef GRIDACCOUNT_H
#define GRIDACCOUNT_H

#include <wx/wx.h>
#include <wx/grid.h>
#include <list>
#include "AccountPanel.h"

class GridAccount : public wxGrid
{
public:
  GridAccount(wxWindow *parent, wxWindowID id) : wxGrid(parent, id) {}
  wxPen GetColGridLinePen (int col) {return wxPen(*wxBLACK, 1, wxSOLID);} 
  wxPen GetRowGridLinePen (int row) {
    if (row == 0 || row == _fixCosts ||
	row == _week1 ||
	row == _week2 ||
	row == _week3)
      return wxPen(*wxBLACK, 1, wxSOLID);
    
    return GetCellBackgroundColour(row, 0);
  } 

  void SetWeek(int week, int line) {
      switch (week) {
      case 1: _week1 = line; break;
      case 2: _week2 = line; break;
      case 3: _week3 = line; break;
      }
  }
  int _fixCosts;
  int _week1, _week2, _week3;
private:
  std::list<int> _col;
};
#endif
